# 🚀 **Ready to master Unix? Let's get started!**

<img src="pages/images/index/flatpak-steam.avif" alt="drawing" width="300"/>
<img src="pages/images/index/MacOSX.png" alt="drawing" width="300"/>

## Course overview

<img src="https://www.svgrepo.com/show/305241/github.svg"
    width="20" height="20"/>
    [GitHub repository]( {{config.repo_url}})


The courses in this repository are designed to guide participants from the fundamentals of the Unix terminal to advanced scripting techniques. It is divided into **three modules**, each focusing on key aspects of Unix usage, from navigating the command line to processing data efficiently and automating tasks with Bash scripting.

## Unix Basics
<!--part1-start-->
**Introduction to the Terminal: Demystifying the Black Screen**

Topics covered include:

- Introduction to the terminal and command line
- Navigating the file system
- Basic commands for file and directory management
- Understanding permissions and file ownership
- Using basic text editors
- Understanding and using bash commands

🎯  **Who is this course for?** 
✅ Beginners who want to gain confidence using the terminal
<!--part1-end-->

## Data & File Manipulation
<!--part2-start-->
**Working with Text and Data**

This part focuses on data and file manipulation using powerful tools like `awk`, `sed`, and `grep`. Topics covered include:

- Searching and filtering with `grep` and `find`  
- Editing and transforming data using `sed` and `awk`  
- Sorting, cutting, and extracting data from structured files  
- Handling large datasets efficiently with Unix tools  
- Combining commands with pipes (`|`) and redirections (`>` and `>>`) 

🎯  **Who is this course for?**  
✅ Anyone needing efficient data manipulation tools  
<!--part2-end-->

## Bash Scripting
<!--part3-start-->
**Automating Tasks in Unix**

This part of the course is dedicated to writing Bash scripts to automate repetitive and complex tasks. Topics covered include:

- Writing and executing Bash scripts (`.sh` files)  
- Understanding variables, loops, and conditionals  
- Handling user inputs and arguments  
- Using functions to structure scripts  
- Error handling and debugging  
- Best practices for writing maintainable scripts  

🎯  **Who is this course for?**  
✅ Anyone looking to automate repetitive tasks in Unix  
<!--part3-end-->
<!--rest-start-->
## Pre-course setup

The [setup](pages/course-information/setup)
page lists the installation and setup of all the tools used in the
course, so make sure you've gone through them all before the course begins.

## Teachers

* Jacques Dainat (course leader)

## Contact

To contact me, please send a mail at {{config.extra.contact}}.

<!--rest-end-->